/*
 * *****************************************************************
 * *                                                               *
 * *    Copyright Compaq Computer Corporation, 2000                *
 * *                                                               *
 * *   The software contained on this media  is  proprietary  to   *
 * *   and  embodies  the  confidential  technology  of  Compaq    *
 * *   Computer Corporation.  Possession, use,  duplication  or    *
 * *   dissemination of the software and media is authorized only  *
 * *   pursuant to a valid written license from Compaq Computer    *
 * *   Corporation.                                                *
 * *                                                               *
 * *   RESTRICTED RIGHTS LEGEND   Use, duplication, or disclosure  *
 * *   by the U.S. Government is subject to restrictions  as  set  *
 * *   forth in Subparagraph (c)(1)(ii)  of  DFARS  252.227-7013,  *
 * *   or  in  FAR 52.227-19, as applicable.                       *
 * *                                                               *
 * *****************************************************************
 */
/*
 * HISTORY
 */
/*
 * @(#)$RCSfile: platform.h,v $ $Revision: 1.1.16.1 $ (DEC) $Date: 1999/10/05 15:37:12 $
 */
#ifndef _ARCH_ALPHA_HAL_PLATFORM_H_
#define _ARCH_ALPHA_HAL_PLATFORM_H_

#include	<sys/types.h>
#include	<machine/rpb.h>
#include	<sys/sysconfig.h>
#include	<sys/errno.h>
#include	<mach/machine.h>
#include	<hal/cpuconf.h>
#include	<io/common/devdriver.h>


/* from arch/alpha/hal/cpusw.c */
extern	u_long          no_dma_map_alloc();
extern	u_long          no_dma_map_load();
extern	int	        no_dma_map_unload();
extern	int             no_dma_map_dealloc();
extern 	int             no_dma_min_bound();
extern	int             no_machcheck();
extern	int             no_harderr_intr();
extern	int             no_softerr_intr();
extern	int             no_memenable();
extern	int             no_config();
extern	int             no_badaddr();
extern	int             no_readtodr();
extern	int             no_writetodr();
extern	int             no_ring_bell();
extern	boolean_t       no_testpage();
extern	int             no_config_secondary();
extern	int             no_init_secondary();
extern	int             no_trans_dumpdev();
extern	int             no_get_info();
extern	int             no_init();
extern	long            no_read_io_port();
extern	void            no_write_io_port();
extern	u_long          no_iohandle_to_phys();
extern	int 	        no_io_copyin();
extern	int             no_io_copyout();
extern	int             no_io_zero();
extern	int             no_io_copyio();

/* from arch/alpha/hal/console.c */
extern	void	hal_pci_cons2dev(struct item_list *, struct bus *);
extern	void	hal_pci_cons2ctl(struct item_list *, struct bus *);
extern	void	hal_pci_dev2cons(struct item_list *, int);
extern	void	hal_pci_dev2user(struct item_list *);
extern	void	hal_pci_dump_dev(struct dump_request *, int);
extern	void	hal_pci_cons_devstr(int, char *, struct device *,
			char *, u_int, u_int);

/*
 * Structure used to describe per-rad/NUMA-centric information.
 */
struct hal_rad {
	int   controlling_cpu;	/* controls config, intr assignment	*/
	int   intr_cpu_mask;	/* per-rad, cpu intr dest.-capable mask */
	int   rad_num;		/* number of this rad 			*/
};

#ifdef  _MULTI_PLATFORM
#define ROUTINE_ENTRYPT(name, param)    PLATFORM()##_##name param
#else
#define ROUTINE_ENTRYPT(name, param)    name param
#endif

#endif /* _ARCH_ALPHA_HAL_PLATFORM_H_ */
