/*
 * *****************************************************************
 * *                                                               *
 * *    Copyright Compaq Computer Corporation, 2000                *
 * *                                                               *
 * *   The software contained on this media  is  proprietary  to   *
 * *   and  embodies  the  confidential  technology  of  Compaq    *
 * *   Computer Corporation.  Possession, use,  duplication  or    *
 * *   dissemination of the software and media is authorized only  *
 * *   pursuant to a valid written license from Compaq Computer    *
 * *   Corporation.                                                *
 * *                                                               *
 * *   RESTRICTED RIGHTS LEGEND   Use, duplication, or disclosure  *
 * *   by the U.S. Government is subject to restrictions  as  set  *
 * *   forth in Subparagraph (c)(1)(ii)  of  DFARS  252.227-7013,  *
 * *   or  in  FAR 52.227-19, as applicable.                       *
 * *                                                               *
 * *****************************************************************
 */
/*
 * HISTORY
 */
/*
 * @(#)$RCSfile: usb_debug.h,v $ $Revision: 1.1.15.2 $ (DEC) $Date: 1999/08/11 19:12:58 $
 */
#ifndef _USB_DEBUG_H
#define _USB_DEBUG_H

/*
 * Uncomment USB_DEBUG to turn on debug.  JANET - Change this
 * to use sysconfigtab
 */
/*
#define USB_DEBUG
*/

#ifdef USB_DEBUG

#define USB_FUNCTION(usb_fn_name) static char *usb_func = "usb_fn_name"
#define USB_DPRINT printf("(%s) ", usb_func); printf

#define USB_TRACE_REQUEST(request, string) {				\
    struct usbd_super_request *super_req = USB_REQUEST2SUPER(request);  \
    super_req->funcq_buf[super_req->funcq_index++] = (string);		\
    if (super_req->funcq_index == USB_REQUEST_FUNCQ)			\
        super_req->funcq_index = 0;					\
}
#define USB_TRACE_DEVICE(device, string) {				\
    (device)->funcq_buf[(device)->funcq_index++] = (string);		\
    if ((device)->funcq_index == USB_DEVICE_FUNCQ)			\
        (device)->funcq_index = 0;					\
}

#define USB_DRIVER_FUNCQ 1024
#define USB_TRACE_DRIVER(string) {					\
    int s;								\
    USB_IPL_LOCK(usbd_funcq_lk, s);					\
    usbd_funcq_buf[usbd_funcq_index++] = (string);			\
    if (usbd_funcq_index == USB_DRIVER_FUNCQ)				\
        usbd_funcq_index = 0;						\
    USB_IPL_UNLOCK(usbd_funcq_lk, s);					\
}

#else /* ! USB_DEBUG */

#define USB_FUNCTION(usb_fn_name);
#define USB_DPRINT
#define USB_TRACE_REQUEST(request, string);
#define USB_TRACE_DEVICE(device, string);
#define USB_TRACE_DRIVER(string);

#endif /* USB_DEBUG */

#endif /* _USB_DEBUG_H */
